/*
One of those Weeks episode 35:BSoDs in Space
Copyright (c) 2008-2009 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.ep35
{
	// Adobe Imports
	import flash.display.SimpleButton;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;

	public class LaserBolt
	extends MovieClip
	{
// ***** CONSTANTS ***********************************************************

		protected static const SPEED:Number = 200.0;
		protected static const LAUNCH_DELTA:Number = .05;
		protected static const DURATION:Number = 2.0;
		
// ***** VARIABLES ***********************************************************

		protected var _xspeed:Number;
		protected var _yspeed:Number;
		protected var _life:Number;

		// note that all _*_movie, _*_btn and _*_txt variables are in movie

// ***** CONSTRUCTOR *********************************************************

		public function LaserBolt()
		{
			trace("Creating laser");
			_xspeed = 0;
			_yspeed = 0;
			visible = false;
		}

// ***** Functions - Event handlers ******************************************


// ***** Functions - General control *****************************************

		public function launch(source:MovieClip)
		{
			var rad:Number = source.rotation * Math.PI/180;
			
			_xspeed = Math.min(SPEED * Math.sin(rad));
			_yspeed = Math.min(SPEED * -Math.cos(rad));
			x = source.x + _xspeed * LAUNCH_DELTA;
			y = source.y + _yspeed * LAUNCH_DELTA;
			rotation = source.rotation;
			visible = true;
			_life = 0;
		}

		public function updatePosition(delta:Number)
		{
			if (!visible)
				return;
			_life += delta;
			if (_life > DURATION)
				visible = false;
			x += _xspeed * delta;
			y += _yspeed * delta;
			if (x < -(width/2))
				x = stage.stageWidth + width/2;
			else if (x > (stage.stageWidth + width /2))
				x = -width/2;

			if (y < -(height/2))
				y = stage.stageHeight + height/2;
			else if (y > (stage.stageHeight + height/2))
				y = -height/2;
		}
	} // end class
} // end package
